# morphy-server-ti-client
API for compressing and expanding text content

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import morphy_server_ti_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import morphy_server_ti_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import morphy_server_ti_client
from morphy_server_ti_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://morphy.ti.trilogy.com/api
# See configuration.py for a list of all supported configuration parameters.
configuration = morphy_server_ti_client.Configuration(
    host = "https://morphy.ti.trilogy.com/api"
)



# Enter a context with an instance of the API client
with morphy_server_ti_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = morphy_server_ti_client.DefaultApi(api_client)
    compress_text_request = morphy_server_ti_client.CompressTextRequest() # CompressTextRequest | 

    try:
        # Compress text to a specified percentage
        api_response = api_instance.compress_text(compress_text_request)
        print("The response of DefaultApi->compress_text:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->compress_text: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://morphy.ti.trilogy.com/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**compress_text**](docs/DefaultApi.md#compress_text) | **POST** /summarize | Compress text to a specified percentage
*DefaultApi* | [**expand_text**](docs/DefaultApi.md#expand_text) | **POST** /expand | Expand text to a specified percentage


## Documentation For Models

 - [CompressText200Response](docs/CompressText200Response.md)
 - [CompressTextRequest](docs/CompressTextRequest.md)
 - [ExpandText200Response](docs/ExpandText200Response.md)
 - [ExpandTextRequest](docs/ExpandTextRequest.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




