# coding: utf-8

"""
    Morphy Text Processing API

    API for compressing and expanding text content

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from morphy_server_ti_client.models.compress_text200_response import CompressText200Response
from morphy_server_ti_client.models.compress_text_request import CompressTextRequest
from morphy_server_ti_client.models.expand_text200_response import ExpandText200Response
from morphy_server_ti_client.models.expand_text_request import ExpandTextRequest

from morphy_server_ti_client.api_client import ApiClient, RequestSerialized
from morphy_server_ti_client.api_response import ApiResponse
from morphy_server_ti_client.rest import RESTResponseType


class DefaultApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def compress_text(
        self,
        compress_text_request: CompressTextRequest,
    ) -> CompressText200Response:
        """Compress text to a specified percentage


        :param compress_text_request: (required)
        :type compress_text_request: CompressTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._compress_text_serialize(
            compress_text_request=compress_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CompressText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def compress_text_with_http_info(
        self,
        compress_text_request: CompressTextRequest,
    ) -> ApiResponse[CompressText200Response]:
        """Compress text to a specified percentage


        :param compress_text_request: (required)
        :type compress_text_request: CompressTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._compress_text_serialize(
            compress_text_request=compress_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CompressText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def compress_text_without_preload_content(
        self,
        compress_text_request: CompressTextRequest,
    ) -> RESTResponseType:
        """Compress text to a specified percentage


        :param compress_text_request: (required)
        :type compress_text_request: CompressTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._compress_text_serialize(
            compress_text_request=compress_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CompressText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        return response_data.response


    def _compress_text_serialize(
        self,
        compress_text_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if compress_text_request is not None:
            _body_params = compress_text_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/summarize',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def expand_text(
        self,
        expand_text_request: ExpandTextRequest,
    ) -> ExpandText200Response:
        """Expand text to a specified percentage


        :param expand_text_request: (required)
        :type expand_text_request: ExpandTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._expand_text_serialize(
            expand_text_request=expand_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExpandText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def expand_text_with_http_info(
        self,
        expand_text_request: ExpandTextRequest,
    ) -> ApiResponse[ExpandText200Response]:
        """Expand text to a specified percentage


        :param expand_text_request: (required)
        :type expand_text_request: ExpandTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._expand_text_serialize(
            expand_text_request=expand_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExpandText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def expand_text_without_preload_content(
        self,
        expand_text_request: ExpandTextRequest,
    ) -> RESTResponseType:
        """Expand text to a specified percentage


        :param expand_text_request: (required)
        :type expand_text_request: ExpandTextRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._expand_text_serialize(
            expand_text_request=expand_text_request,
            _request_auth=None,
            _content_type=None,
            _headers=None,
            _host_index=0
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExpandText200Response",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=None
        )
        return response_data.response


    def _expand_text_serialize(
        self,
        expand_text_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if expand_text_request is not None:
            _body_params = expand_text_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/expand',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


